<?php

// Handling query strings
//print_r($_GET);
//echo '<br />';

// We'll want to use the id and keycode to accept the values
extract($_GET);

if(isset($id) && isset($keycode)){
	// TODO: Query the database to find this entry
	// For now, use a dummy var
	if($id == 123 && $keycode == 4){
		/* Load required lib files. */
		session_start();
		// For reading from config ini
		require_once('includes/custom_functions.php');
		require_once('twitteroauth/twitteroauth.php');
		require_once('config/config.php');
		
		// Load data from user config
		$ini_array = parse_ini_file($path_for_user_settings, true);
		$operating_mode = $ini_array['general']['operating_mode'];
		$scrolling_mode = $ini_array['general']['scrolling_mode'];
		$scrolling_speed = $ini_array['general']['scrolling_speed'];
		$twitter_user = $ini_array['mode_1']['twitter_user'];
		$static_text = $ini_array['mode_100']['text_to_display'];
		// Mode 0 includes everything, mode 1 excludes hashtags, mode 2 includes only hashtags
		$hashtag_mode_current_trends = $ini_array['mode_3']['hashtag_mode'];	
		$hashtag_mode_current_daily = $ini_array['mode_4']['hashtag_mode'];
		
		
		// Setting it to TweetSign's info - ideally this should be the user's
		$access_token['oauth_token'] = OAUTH_ACCESS_TOKEN;
		$access_token['oauth_token_secret'] = OAUTH_TOKEN_SECRET;

		/* Create a TwitterOauth object with consumer/user tokens. */
		$connection = new TwitterOAuth(CONSUMER_KEY, CONSUMER_SECRET, $access_token['oauth_token'], $access_token['oauth_token_secret']);

		// GET THE NECESSARY METHODS FROM HERE:
		// https://dev.twitter.com/docs/api


		/* If method is set change API call made. Test is called by default. */
		$content = $connection->get('account/rate_limit_status');
		//echo "Current API hits remaining: {$content->remaining_hits}.";
		//echo "<br />";


		// /* Get logged in user to help with tests. */
		// $user = $connection->get('account/verify_credentials');
		// echo "Currently logged in as {$user->name}";
		// echo "<br />";

		if( $operating_mode == 0){
			// -------------------------------------------
			// Get a random user's tweet - mode 0
			// https://dev.twitter.com/docs/api/1/get/statuses/public_timeline
			$method = 'statuses/public_timeline';
			$parameters = array('trim_user' => 'true');
			$content = $connection->get($method, $parameters);
			//print_r($content);
			// The zero for the index should be a random number
			//echo "Random tweet: {$content[0]->text}";
			echo $content[0]->text;
			//echo "<br />";
		}
		else if($operating_mode == 1)
		{
			// -------------------------------------------
			/* Get a specific user's latest tweet - mode 1 */
			// 
			$method = 'statuses/user_timeline';
			$user = $twitter_user; // From config
			$parameters = array('screen_name' => $user);
			$content = $connection->get($method, $parameters);
			// print_r($content);
			//echo "Jack's latest tweet: {$content[0]->text}";
			echo "@" . $user . ": " . $content[0]->text;
			//echo "<br />";
		}
		else if($operating_mode == 2)
		{
		// Mode 2 skipped for now
		}
		else if($operating_mode == 3)
		{
			// ------------------------------------------
			// Show the current Trends on Twitter - mode 3
			// https://dev.twitter.com/docs/api/1/get/trends/%3Awoeid

			$method = 'trends/1'; // The 1 is the woeid -> represents Worldwide
			// Hashtag Mode 0 includes everything, mode 1 excludes hashtags, mode 2 includes only hashtags
			$hashtag_mode = $hashtag_mode_current_trends;
			//$parameters = array('exclude' => 'hashtags');
			$content = $connection->get($method);
			// $content[0] includes a created_at, locations, trends, and as_of field
			$trends = $content[0]->trends;
			$str_output = handleTrends($trends, $hashtag_mode);
			//print_r($content[0]->trends);
			echo "$str_output";
		}
		else if($operating_mode == 4)
		{
			// -------------------------------------------
			// Show the trend from today for a specific time of day - mode 4
			// https://dev.twitter.com/docs/api/1/get/trends/daily
			$method = 'trends/daily'; 
			// Hashtag Mode 0 includes everything, mode 1 excludes hashtags, mode 2 includes only hashtags
			$hashtag_mode = $hashtag_mode_current_daily;
			//$parameters = array('exclude' => 'hashtags');
			$content = $connection->get($method);
			$trends = objectToArray($content->trends);
			//$trends = array_shift(array_values($trends));
			$trends = current($trends);
			//print_r($trends);
			// =====================================
			// CHANGE THIS TO USE THE OTHER FUNCTION
			// =====================================
			$str_output = "";
			// Each trend has name, url, and query fields
			// Hashtag Mode 0 includes everything, mode 1 excludes hashtags, mode 2 includes only hashtags
			foreach ($trends as $arr){
				$trend = $arr['name'];
				if($hashtag_mode == 0){
					$str_output .= $trend . ', ';
				}else if($hashtag_mode == 1){
					// remove hashtags
					if(!startsWith($trend,'#')){
						$str_output .= $trend . ', ';
					}
				}else{
					// only include hashtags
					if(startsWith($trend,'#')){
						$str_output .= $trend . ', ';
					}	
				}
			}
			// Remove the last comma
			$str_output = substr($str_output, 0,-2);
			//$str_output = handleTrends($trends, $hashtag_mode);
			echo "$str_output";
		}
		else if($operating_mode == 100)
		{
			// -------------------------------------------
			// Static text - mode 100
			echo $static_text;
		}
		else
		{
			echo 'Incorrect Mode Specified.';
		}
	}else if($id == 777 && $keycode == 777){
		// Setting up random tweets
		$tweets = array('That taste in your mouth when you wake up after a night of drinking', 'Rock that voodoo like I just stepped outta scary moviee!! RT @SweetBerryRami: What they like? Louis Gucci.', 'Gym after Chruch , who coming?!', 'General Knowledge: \nHazrat Usman (RA) Was The First Hafiz Of The Holy Quran.', 'Eten x', 'Going back to lifetime today...', 'http://t.co/uaI2FYfz', 'El amor es como los fantasmas, muchos hablan de el pero pocos lo han conocido', 'Getting ready to go to work! #HopeItGoesByFast', 'Sono stanca!!! Twittate #ItalianSelenatorsLoveSelena', 'My NY friends complain I never have to shovel in LA. Yeah? You think these heaps of broken dreams will get off the sidewalk themselves?', 'What not to do on a first date: ask what gender they are.', 'I\'m one of those people that tried this at home.','My son answered a test question "What causes the earth to rotate?" with "Fat bottomed girls." He failed the test but won my RESPECT.','Thank you, possum, for rustling outside the window when some show about serial killers is on. It really helped with my insomnia.');

		$random_key = array_rand($tweets);
		$random_tweet = $tweets[$random_key];
		echo $random_tweet;
	}else if($id == 456 && $keycode == 7){
		echo 'Hello!  This is a tweet.  It will be the same.';
	}else{
		echo 'ERROR: No matching user found in database.  Please contact support.';
	}
	
}else{
	echo 'Incorrect parameters passed.';
}

// Function that handles the hashtags
function handleTrends($trends, $hashtag_mode){
	$str_output = "";
	// Each trend has name, url, and query fields
	// Hashtag Mode 0 includes everything, mode 1 excludes hashtags, mode 2 includes only hashtags
	foreach ($trends as $obj){
		$trend = $obj->name;
		if($hashtag_mode == 0){
			$str_output .= $trend . ', ';
		}else if($hashtag_mode == 1){
			// remove hashtags
			if(!startsWith($trend,'#')){
				$str_output .= $trend . ', ';
			}
		}else{
			// only include hashtags
			if(startsWith($trend,'#')){
				$str_output .= $trend . ', ';
			}	
		}
	}
	// Remove the last comma
	$str_output = substr($str_output, 0,-2);
	
	return $str_output;
}

 // Function from http://stackoverflow.com/questions/834303/php-startswith-and-endswith-functions
function startsWith($haystack, $needle)
{
    $length = strlen($needle);
    return (substr($haystack, 0, $length) === $needle);
}

/* Function from http://www.if-not-true-then-false.com/2009/php-tip-convert-stdclass-object-to-multidimensional-array-and-convert-multidimensional-array-to-stdclass-object/
*/
function objectToArray($d) {
	if (is_object($d)) {
		// Gets the properties of the given object
		// with get_object_vars function
		$d = get_object_vars($d);
	}

	if (is_array($d)) {
		/*
		* Return array converted to object
		* Using __FUNCTION__ (Magic constant)
		* for recursive call
		*/
		return array_map(__FUNCTION__, $d);
	}
	else {
		// Return array
		return $d;
	}
}


?>